/*var contacts = [{
		name: "Slávek",
		surname: "Müller",
		tags: "#prvni, #druhy",
		street: "Ulice 49",
		zipcode: "12345",
		town: "Praha",
		mails: [{
				name: "Mail 1",
				value: "lorem@ipsum.com"
			},{
				name: "Mail 2",
				value: "lo2@ipsum.com"
			}],
		phones: [{
				name: "Telefon 1",
				value: "+420123456789"
			},{
				name: "Telefon 2",
				value: "+420987654321"
			}]

	}, {
		name: "Jan",
		surname: "Grepl",
		tags: "#treti, #ctvrty",
		street: "Ulice 59",
		zipcode: "67891",
		town: "Praha"
	}, {
		name: "Martin",
		surname: "Bradáč",
		tags: "#paty, #sesty",
		street: "Ulice 69",
		zipcode: "01112",
		town: "Praha"
	}, {
		name: "Pavel",
		surname: "Polcr",
		tags: "#sedmy, #osmy",
		street: "Ulice 79",
		zipcode: "13145",
		town: "Praha"
	},
];
*/

var contacts = JSON.parse(localStorage.contacts);

// Seřadíme pole kontaktů podle jména
function sortByName(a,b) {
  if (a.surname < b.surname)
    return -1;
  if (a.surname > b.surname)
    return 1;	
  if (a.name < b.name)
    return -1;
  if (a.name > b.name)
    return 1;
  return 0;
}

var Contact = {
	// Vypíšeme abecedu vedle seznamu jmen
	renderAlphabet: function() {
		var alphabet = "abcdefghijklmnopqrstuvwxyz".split("");
		for (var index in alphabet)
			$("ul.alphabet").append("<li>"+alphabet[index]+"</li>");

		$("ul.alphabet li").click(Contact.goToLetter);
	},

	// Odskroluj na určité písmenko
	goToLetter: function() {
		var letter = $(this).text();
		var scrolled = false;

		$(".list ul.contacts li").each(function() {
			var nameFirstLetter = $(this).text().trim()
						.replace(/\n|\t/g, ' ')	// odstranit taby a nové řádky
						.replace(/ +(?= )/g,'')	// nahradit více mezer za jednu
						.toLowerCase().substr(0, 1); // jméno osoby
			if (nameFirstLetter == letter && scrolled == false) {
				scrolled = true;
				var top = $(this).position().top;
				$("ul.contacts").scrollTop(top);
			}

		});
	},

	// Filtrovat kontakty podle hledání
	search: function() {
		var string = $(this).val().trim().toLowerCase(); // hledaný řetězec

		$(".list ul.contacts li").each(function() {
			var name = $(this).text().trim()
						.replace(/\n|\t/g, ' ')	// odstranit taby a nové řádky
						.replace(/ +(?= )/g,'')	// nahradit více mezer za jednu
						.toLowerCase(); // jméno osoby

			$(this).addClass("hide");
			if (name.indexOf(string) > -1)
				$(this).removeClass("hide");
		});
	},

	// Vyrenderujeme seznam jmen
	renderContactList: function() {
		$("ul.contacts").text("");
		contacts.sort(sortByName);
		for (var index in contacts) {
			var person = contacts[index];
			$("ul.contacts").append("<li data-id='"+index+"'>\
				<span class='name'>"+person.name+"</span>\
				<span class='surname'>"+person.surname+"</span>\
				</li>");
		}
		Contact.afterListRender();
	},

	// Vykonáme věci, které se musí udělat po vyrenderování seznamu kontaktů
	afterListRender: function() {
		$(".contacts li").click(Contact.showContactDetail);
	},

	// Zobrazit detail kontaktu
	showContactDetail: function(event) {
		// Podbarvit modře
		$(".contacts li.active").removeClass("active");
		if (typeof event == "object")
			$(this).addClass("active");

		$(".homepage, .contact-edit-detail").addClass("hide");
		$(".contact-detail").removeClass("hide");
		
		var id = contacts.length;
		var person = {
			name: "",
			surname: "",
			tags: "",
			street: "",
			zipcode: "",
			town: ""
	
		};
		if (typeof event == "object") {
			id = $(this).data("id");
			person = contacts[id]
		}

		$(".contact-edit-detail").data("edit-id", id)
		for (var property in person)
			$("[data-fill='"+property+"']").text(person[property]).val(person[property]);

		// Vložíme všechny maily a telefonní čísla do příslušných elementů
		$(".static-mails, .static-phones, .input-mails, .input-phones").text("");
		if (person.mails) {
			for (var index in person.mails) {
				var mail = person.mails[index];

				$(".static-mails").append('\
					<div class="col col-2-5 property-name">'+mail.name+':</div>\
					<div class="col col-3-5 property-value">\
						<a href="mailto:'+mail.value+'">'+mail.value+'</a>\
					</div>');

				$(".input-mails").append('\
					<div class="input-group">\
						<div class="col col-2-5 property-name with-input">\
							<input type="text" class="valid edit-input" value="'+mail.name+'">\
						</div>\
						<div class="col col-3-5 property-value form-group">\
							<input type="text" class="valid edit-input" value="'+mail.value+'">\
							<button class="btn btn-red btn-wider btn-higher">\
								<i class="icon icon-close"></i>\
							</button>\
						</div>\
					</div>');
			}
		}
		if (person.phones) {
			for (var index in person.phones) {
				var phone = person.phones[index];

				$(".static-phones").append('\
					<div class="col col-2-5 property-name">'+phone.name+':</div>\
					<div class="col col-3-5 property-value">\
						<a href="tel:'+phone.value+'">'+phone.value+'</a>\
					</div>');

				$(".input-phones").append('\
					<div class="input-group">\
						<div class="col col-2-5 property-name with-input">\
							<input type="text" class="valid edit-input" value="'+phone.name+'">\
						</div>\
						<div class="col col-3-5 property-value form-group">\
							<input type="text" class="valid edit-input" value="'+phone.value+'">\
							<button class="btn btn-red btn-wider btn-higher">\
								<i class="icon icon-close"></i>\
							</button>\
						</div>\
					</div>');
			}
		}		
	},

	// Skrýt detail kontaktu
	closeContactDetail: function() {
		$(".homepage").removeClass("hide");
		$(".contact-detail, .contact-edit-detail").addClass("hide");
		$(".contacts li.active").removeClass("active");
	},

	// Zobrazit formulář pro přidání nového kontaktu
	showNewForm: function() {
		Contact.showContactDetail();
		Contact.showEditForm();
	},

	// Zobrazit formulář na editaci kontaktu
	showEditForm: function() {
		$(".contact-edit-detail").removeClass("hide");
		$(".homepage, .contact-detail").addClass("hide");
	},

	// Skrýt nebo zobrazit jména v seznamu
	toggleNames: function() {
		$(".contacts li .name").toggleClass("hide");
	},

	// Vymazat všechny kontakty z paměti
	deleteAll: function() {
		Contact.showNewForm(); // vymazat všechny políčka
		localStorage.setItem("contacts", JSON.stringify([]));
		$(".homepage").removeClass("hide");
		$(".contact-detail, .contact-edit-detail").addClass("hide");
		$(".contacts li.active").removeClass("active");	

		contacts = JSON.parse(localStorage.contacts);	
		Contact.renderContactList();
	},

	// Bylo změněno nějaké políčko - uložit
	saveForm: function() {
		var id = $(".contact-edit-detail").data("edit-id")
		var name = $(this).data("fill");
		var value = $(this).val();
		if (contacts[id])
			contacts[id][name] = value;
		else {			
			contacts[id] = {};
			contacts[id][name] = value;
		}
		localStorage.setItem("contacts", JSON.stringify(contacts));
	},

	// Zavřít editaci
	closeEditDetail: function() {
		$(".contact-detail").removeClass("hide");
		$(".homepage, .contact-edit-detail").addClass("hide");
		contacts = JSON.parse(localStorage.contacts);	
		Contact.renderContactList();	
		$("ul.contacts li[data-id='"+$(".contact-edit-detail").data("edit-id")+"']").click();	
	},	
};

$(function() {
	Contact.renderAlphabet()
	Contact.renderContactList();

	// Hledání v políčku
	$(".search input").on("keyup", Contact.search);

	// Zavřít detail
	$(".contact-detail .icon-close-gray").click(Contact.closeContactDetail);

	// Uložit editaci
	$(".save-edit-detail").click(Contact.closeEditDetail);

	// Zobrazit editaci
	$(".edit-contact").click(Contact.showEditForm);

	// Přidat nový kontakt
	$(".add-contact").click(Contact.showNewForm);

	// Skrýt ve výpisu jména
	$(".hide-names").click(Contact.toggleNames);

	// Smazat všechny kontakty
	$(".delete-all").click(function() {
		var confirm = window.confirm("Opravdu si přejete vymazat všechny kontakty?");
		if (confirm == true)
			Contact.deleteAll();
	});

	$("input.edit-input[data-fill]").on("keyup", Contact.saveForm);
})